/* Copyright 1998-2011 Research Foundation State University of New York */

/* This file is part of QuB.                                            */

/* QuB is free software; you can redistribute it and/or modify          */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation, either version 3 of the License, or    */
/* (at your option) any later version.                                  */

/* QuB is distributed in the hope that it will be useful,               */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/* GNU General Public License for more details.                         */

/* You should have received a copy of the GNU General Public License,   */
/* named LICENSE.txt, in the QuB program directory.  If not, see        */
/* <http://www.gnu.org/licenses/>.                                      */

#ifndef QUB_LMFITTER_H
#define QUB_LMFITTER_H

#include "qubfits.h"

class QUB_LMFitter : public IQUB_Fitter
{
public:
	QUB_LMFitter();
	void __cdecl Free();
	IQUB_Evts * __cdecl Events();
	const char * __cdecl getName();
	int __cdecl getParamCount();
	const char * __cdecl getParamName(int ix);
	double __cdecl getParamVal(int ix);
	void __cdecl setParamVal(int ix, double val);
	int __cdecl Fit(IQUB_Curve* curve, QF_Data **data, int ndata);
	void __cdecl Stop(); // from another thread
	int __cdecl getIterations();
	double __cdecl getParamErr(int ix);
	double * __cdecl getCurve();
	const char * __cdecl getMessage(); // if directed by event
	QTR_Impl* __cdecl getState();
	void __cdecl updateState(QTR_Impl* state);

	void evaluate(double* par, double* fvec, int *info);
	void print(double* par, double* fvec, int iflag, int iter, int nfev);
private:
	QUB_Evts events;
	QUB_Tree state;
	vector<double> params;
	IQUB_Curve* curve;
	vector<QF_Data*> data;
	int n;
	vector<int> useCpar;
	vector< vector<double> > fff;
	int iter;
	vector<double> errors;
	string msg;
	bool stopRequested;
	
	void setupData(QF_Data **adata, int ndata);
};

IQUB_Fitter* __stdcall CreateLMFitter();


#endif
